Uses UniGr, Crt, Colors, Keyb;
Const
     MaxStar = 200;
     MaxLines = 255;
     MaxPicture = 60;
     MaxFire = 32;
     MaxFPixel = 32;
     MaxMonster = 32;
Type StarType = record
       X, Y, Spd : Real;
       Color : Byte;
       _X, _Y : Integer;
     End;
     FireType = record
       Shield : Integer;
       X, Y : Real;
       Spd, Angle : Real;
       Profile : Integer;
       _X, _Y : Integer;
       On : Byte;
       Typ : Byte;
     End;
     FirePixelType = record
       On : Byte;
       X, Y : Real;
       Ang : Real;
       Spd : Real;
       _X, _Y : Integer;
     End;
     MonsterType = record
       X, Y : Real;
       Prog : Integer;
       Var1 : Integer;
       Var2 : Integer;
       Var3 : Integer;
       On : Byte;
       _X, _Y : Integer;
     End;
Var Star : Array[1..MaxStar] of StarType;
    Fire : Array[1..MaxFire] of FireType;
    MyScreen : PScreen;
    Map : Array[1..11, 1..MaxLines] Of Char;
    MapLeng : Integer;
    Palette : Array[0..3*255+2] Of Byte;
    Picture : Array[1..MaxPicture] Of Pointer;
    FPixel : Array[1..MaxFPixel] Of FirePixelType;
    Monster : Array[1..MaxMonster] Of MonsterType;
    Clk : Byte;
    StartX, StartY : Integer;
    Shield : Integer;
    ShieldRel : Integer;

Var Speed : Real;
    MainPos : Real;
    MapPos : Integer;
    I, X, Y : Integer;
    ShipX, ShipY : Real;
    ShipDir : Integer;
    ShipDX : Real;
    _ShipX, _ShipY : Integer;
    Charge : Integer;

Procedure InitFirePixels;
Var I : Integer;
Begin
  For I := 1 to MaxFPixel do
    FPixel[I].On := 0;
End;
Procedure NewFirePixel(X, Y : Integer; Ang : Real; Spd : Real);
Var I : Integer;
Begin
  For I := 1 to MaxFPixel do
    If FPixel[I].On = 0 Then
    Begin
      FPixel[I].On := 1;
      FPixel[I].X := X;
      FPixel[I].Y := Y;
      FPixel[I].Ang := Ang;
      FPixel[I].Spd := Spd;
      FPixel[I]._X := X;
      FPixel[I]._Y := Y;
      Exit;
    End;
End;
Procedure Explosion(X, Y, Cnt : Integer);
Var I : Integer;
Begin
  For I := 1 to Cnt do
    NewFirePixel(X, Y, random(Trunc(2*PI*1000))/1000, 2);
End;
Procedure Exploding;
Var I : Integer;
Begin
  For I := 1 to MaxFPixel do
    If FPixel[I].On = 1 Then
    Begin
      FPixel[I].X := FPixel[I].X + Cos(FPixel[I].Ang)*FPixel[I].Spd;
      FPixel[I].Y := FPixel[I].Y + Sin(FPixel[I].Ang)*FPixel[I].Spd;
      FPixel[I]._X := Trunc(FPixel[I].X);
      FPixel[I]._Y := Trunc(FPixel[I].Y);
      If (FPixel[I]._X < 0) Or (FPixel[I]._X > 320) Or
         (FPixel[I]._Y < 0) Or (FPixel[I]._Y > 200) Then
        FPixel[I].On := 0;
    End;
End;
Procedure DrawExplosion;
Var I : Integer;
Begin
  For I := 1 to MaxFPixel do
    If FPixel[I].On = 1 Then
      PutPixel(MyScreen, FPixel[I]._X, FPixel[I]._Y, 11);
End;
Function Sgn(I : Integer) : ShortInt;
Begin
  If I = 0 Then Sgn := 0;
  If I < 0 Then Sgn := -1;
  If I > 0 Then Sgn := +1;
End;
Function Angle(X, Y : Real) : Real;
Var NAngle : Real;
Begin
  IF Y <> 0 THEN
    NAngle := ARCTAN(X / Y)
  ELSE
    NAngle := PI / 2;

  NAngle := PI / 2 - NAngle;
  IF Y < 0 THEN NAngle := NAngle + PI;
  Angle := NAngle;
End;
Function Angle2Dir(Ang : Real) : Integer;
Var A1 : Real;
Begin
  A1 := Ang + PI / 4;
  If A1 > 2*PI Then A1 := Ang - 2*PI;
  Angle2Dir := Trunc(A1*2/PI);
  {0 -> right
   1 -> down
   2 -> left
   3 -> up}
End;


Procedure LoadMap;
Var F : Text;
    Line : String;
    I : Integer;
Begin
  Assign(F, 'mapa.bin');
  Reset(F);
  MapLeng := 0;
  While not Eof(F) do
  Begin
    Inc(MapLeng);
    ReadLn(F, Line);
    For I := 1 to 11 do
    Begin
      If Line[I] = 'S' Then
      Begin
        StartX := I;
        StartY := MapLeng;
        Line[I] := ' ';
      End;
      Map[I, MapLeng] := Line[I];
    End;
  End;
  Close(F);
End;
Function Conv(Ch : Char) : Integer;
Begin
  Conv := 0;
  If Ch = 'a' Then Conv := 01;
  If Ch = 'b' Then Conv := 11;
  If Ch = 'c' Then Conv := 21;
  If Ch = 'd' Then Conv := 31;
  If Ch = 'A' Then Conv := 02;
  If Ch = 'B' Then Conv := 12;
  If Ch = 'C' Then Conv := 22;
  If Ch = 'D' Then Conv := 32;

  If Ch = 'e' Then Conv := 03;
  If Ch = 'f' Then Conv := 04;
  If Ch = 'g' Then Conv := 05;
  If Ch = 'h' Then Conv := 06;
  If Ch = 'E' Then Conv := 13;
  If Ch = 'F' Then Conv := 14;
  If Ch = 'G' Then Conv := 15;
  If Ch = 'H' Then Conv := 16;

  If Ch = 'o' Then Conv := 41;
  If Ch = 'O' Then Conv := 42;
  If Ch = 'l' Then Conv := 51;
  If Ch = 'L' Then Conv := 52;

  If Ch = 'i' Then Conv := 43;
  If Ch = 'I' Then Conv := 44;
  If Ch = 'k' Then Conv := 53;
  If Ch = 'K' Then Conv := 54;

  If Ch = '0' Then Conv := 23;

  If Ch = '>' Then Conv := 7+(Clk div 16) mod 4;
  If Ch = '}' Then Conv := 56 + (Clk div 16) mod 5;
  If Ch = '-' Then Conv := 46 + (Clk div 32) mod 2;
  If Ch = ']' Then Conv := 39;
  If Ch = '[' Then Conv := 40;
  If Ch = ')' Then Conv := 37;
End;
Procedure AddMonster(X, Y, Typ : Integer);
Var I : Integer;
Begin
  For I := 1 to MaxMonster do
    If Monster[I].On = 0 Then
    Begin
      Monster[I].On := 1;
      Monster[I].Prog := Typ;
      Monster[I].X := X;
      Monster[I].Y := Y;
      Monster[I]._X := X;
      Monster[I]._Y := Y;
      If Typ = 1 Then
      Begin
        Monster[I].Var1 := 1;
        Monster[I].Var2 := 320;
        Monster[I].Var3 := 0;
      End;
      Break;
    End;
End;
Procedure DrawMonster;
Var I : Integer;
Begin
  For I := 1 to MaxMonster do
    If Monster[I].On = 1 Then
      PutImgNull(MyScreen, Monster[I]._X, Monster[I]._Y,
                 Picture[17+(Clk div 20) mod 4]);
End;
Procedure MoveMonster;
Var I : Integer;
Begin
  For I := 1 to MaxMonster do
    If (Monster[I].On = 1) And (Monster[I].Prog = 1) Then
    Begin
      If Monster[I].Var1 = 1 Then
      Begin
        If (Monster[I].Var2 > 0) Then
        Begin
          Dec(Monster[I].Var2);
          Dec(Monster[I]._X);
        End Else
        Begin
          Monster[I].Var1 := 2;
          Monster[I].Var2 := 0;
        End;
      End;
      If Monster[I].Var1 = 2 Then
      Begin
        Inc(Monster[I]._Y);
        If Monster[I]._Y > 200 Then
        Begin
          Monster[I].On := 0;
        End;
      End;
    End;
End;
Procedure NewMonster(Typ : Integer);
Var I : Integer;
Begin
  If Typ = 1 Then
  Begin
    For I := 1 to 4 do
      AddMonster(320+I*20, 20, 1);
  End;
End;
Procedure GenerateStar(I, Pos : Integer);
Begin
  Star[I]._X := random(320-1)+1;
  If Pos > 0 Then Star[I]._Y := 0;
  If Pos < 0 Then Star[I]._Y := 200;
  If Pos = 0 Then Star[I]._Y := Random(200);
  Star[I].Spd := Random(100)/100;
  Star[I].Color := 208+Trunc(Star[I].Spd*8);
  Star[I].X := Star[I]._X;
  Star[I].Y := Star[I]._Y;
End;
Procedure MoveStar(I : Integer; Dir : Real);
Begin
  If Dir = 0 Then Exit;
  Star[I].Y := Star[I].Y + Star[I].Spd*Dir;
  If (Dir > 0) And (Star[I].Y > 200) Then
    GenerateStar(I, +1);
  If (Dir < 0) And (Star[I].Y < 0) Then
    GenerateStar(I, -1);
  Star[I]._Y := Trunc(Star[I].Y);
End;
Procedure ShowStar(I : Integer);
Begin
  PutPixel(MyScreen, Star[I]._X, Star[I]._Y, Star[I].Color);
End;

Procedure InitStars;
Var I : Integer;
Begin
  For I := 1 to MaxStar do
    GenerateStar(I, 0);
End;
Procedure InitFires;
Var I : Integer;
Begin
  For I := 1 to MaxFire do
    Fire[I].On := 0;
End;
Procedure ShowFires(YSub : Integer);
Var I : Integer;
Begin
  For I := 1 to MaxFire do
    If (Fire[I].On = 1) Then
    Begin
      If Fire[I].Profile = 0 Then
      Begin
        PutPixel(MyScreen, Fire[I]._X+0, Fire[I]._Y+0-YSub, 15);
        PutPixel(MyScreen, Fire[I]._X+0, Fire[I]._Y+1-YSub, 15);
        PutPixel(MyScreen, Fire[I]._X+1, Fire[I]._Y+0-YSub, 15);
        PutPixel(MyScreen, Fire[I]._X+1, Fire[I]._Y+1-YSub, 15);
      End Else
        PutImgNull(MyScreen, Fire[I]._X-16, Fire[I]._Y-16-YSub,
                   Picture[Fire[I].Profile]);
    End;
End;
Function TestAttack(X, Y : Integer) : Boolean;
Var OfsX, OfsY : Integer;
    Pix : Byte;
Begin
  If (Abs(X-_ShipX)<14) And (Abs(Y-_ShipY-MapPos)<14) Then
  Begin
   OfsX := _ShipX-X+15;
   OfsY := _ShipY-Y+MapPos+15;
   If (OfsX < 0) Or (OfsY < 0) Or
      (OfsX >= 32) Or (OfsY >= 32) Then
   Begin
     halt;
   End;
   OfsX := 31-OfsX;
   OfsY := 31-OfsY;
   Pix := PArray(Picture[24])^[2+OfsX+OfsY*32];
   If Pix = 0 Then TestAttack := False Else TestAttack := True;
  End
  Else
   TestAttack := False;

End;
Function GetMapObj(X, Y : Integer) : Char;
Var tX, tY : Integer;
Begin
  tX := (X shr 5) +1;
  tY := (Y shr 5) +1;
  If (tX > 0) And (tY > 0) And
     (tX < 11) And (tY < MapLeng) Then
  Begin
    GetMapObj := Map[tX, tY];
  End Else GetMapObj := ' ';
End;
Procedure SetMapObj(X, Y : Integer; Obj : Char);
Var tX, tY : Integer;
Begin
  tX := (X shr 5) +1;
  tY := (Y shr 5) +1;
  If (tX > 0) And (tY > 0) And
     (tX < 11) And (tY < MapLeng) Then
  Begin
    Map[tX, tY] := Obj;
  End;
End;

Procedure MoveFires(YSub : Integer);
Var I, J : Integer;
Begin
  For I := 1 to MaxFire do
    If (Fire[I].On = 1) Then
    Begin

      If Fire[I].Typ = 1 Then
      Begin
        For J := 1 to MaxFire do
          If (Fire[J].On = 1) And
             (Fire[J].Typ = 2) And
             (abs(Fire[J]._X-Fire[I]._X)<4) And
             (abs(Fire[J]._Y-Fire[I]._Y)<4) Then
          Begin
            Fire[J].On := 0;
            Explosion(Fire[I]._X, Fire[I]._Y-MapPos, 4);
          End;
      End;

      If Fire[I].Shield > 0 Then Dec(Fire[I].Shield);
      If Fire[I]._Y-YSub < -16 Then Fire[I].On := 0;
      If Fire[I]._Y-YSub > 200 Then Fire[I].On := 0;
      If Fire[I]._X > 320 Then Fire[I].On := 0;
      If Fire[I]._X < -16 Then Fire[I].On := 0;
      If (Fire[I].Shield = 0) And (Fire[I].Typ = 1) Then
      Begin
        If GetMapObj(Fire[I]._X, Fire[I]._Y) = '>' Then
        Begin
          SetMapObj(Fire[I]._X, Fire[I]._Y, ')');
          Explosion(Fire[I]._X, Fire[I]._Y-MapPos, 40);
          Fire[I].On := 0;
        End;

      End;
      Fire[I].Y := Fire[I].Y + Cos(Fire[I].Angle) * Fire[I].Spd;
      Fire[I].X := Fire[I].X + Sin(Fire[I].Angle) * Fire[I].Spd;
      Fire[I]._X := Trunc(Fire[I].X);
      Fire[I]._Y := Trunc(Fire[I].Y);
      If (Fire[I].Shield = 0) And (Fire[I].Typ = 2) And
         (TestAttack(Fire[I]._X, Fire[I]._Y)) Then
      Begin
        ShieldRel := -16;
        Fire[I].On := 0;
        Explosion(Fire[I]._X, Fire[I]._Y-MapPos, 20);
      End;
{      Fire[I].Spd := Fire[I].Spd + 0.4;}
    End;
End;

Procedure NewFire(X, Y : Integer; Angle : Real; Spd : Real; Class : Byte);
Var I, Dir : Integer;
Begin
  For I := 1 to MaxFire do
    If (Fire[I].On = 0) Then
    Begin
      Fire[I].On := 1;
      Fire[I].Profile := 0;
      Fire[I].Angle := Angle;
      Fire[I].Spd := Spd;
      If Class = 1 {player shoot} Then
      Begin
        Fire[I].Shield := 8;
        Dir := Angle2Dir(Angle);
        If Dir = 0 Then Fire[I].Profile := 34;
        If Dir = 1 Then Fire[I].Profile := 35;
        If Dir = 2 Then Fire[I].Profile := 33;
        If Dir = 3 Then Fire[I].Profile := 36;
        Fire[I].Typ := 1;
      End;
      If Class = 0 {fire} Then
      Begin
        Fire[I].Shield := 0;
        Fire[I].Profile := 0;
        Fire[I].Typ := 2;
      End;
      Fire[I].X := X;
      Fire[I].Y := Y;
      Fire[I]._X := Trunc(X);
      Fire[I]._Y := Trunc(Y);
      Break;
    End;
End;
Procedure MoveStars(Dir : Real);
Var I : Integer;
Begin
  For I := 1 to MaxStar do
    MoveStar(I, Dir);
End;
Procedure ShowStars;
Var I : Integer;
Begin
  For I := 1 to MaxStar do
    ShowStar(I);
End;

Function Test : Boolean;
Var Tx, Ty, Pic, Pix, OffsX, OffsY : Integer;
    Obj : Char;
Begin
  Tx := Trunc(ShipX + ShipDX*4) shr 5 +1;
  Ty := Trunc(ShipY + Speed*4) shr 5 +1;
  Obj := #0;
  If (ty > 0) And (ty <= MapLeng) And
     (tx > 0) And (tx <= 10) Then
    Obj := Map[tX, tY];

  If (Obj = #0) Or (Obj = ' ') Then
    Test := True
  Else
  Begin
    OffsX := Trunc(ShipX + ShipDX*4) and 31;
    OffsY := Trunc(ShipY + Speed*4)  and 31;
    Pic := Conv(Obj);
    Pix := PArray(Picture[Pic])^[2+OffsX+OffsY*32];
    If Pix = 0 Then Test := True Else Test := False;
  end;
End;
Procedure ShowMap(YSub : Integer);
Var X, Y, mX, mY, Pic : Integer;
Begin
  For Y := 1 to 8 Do
    For X := 1 to 10 Do
    Begin
      mX := X;
      mY := Y+YSub Shr 5;
      Pic := 0;
      If (mY > 0) And (mY <= MapLeng) Then
      Begin
        Pic := Conv(Map[mX, mY]);
      End;
      If (Pic <> 0) And (Y < 200) Then
        PutImgNULL32(MyScreen, X*32-32, Y*32-32-YSub And 31, Picture[Pic]);
    end;
End;
Procedure ProcMap(YSub : Integer);
Var X, Y, mX, mY : Integer;
Begin

  If (Map[11, YSub shr 5] = '*') Then
  Begin
    Map[11, YSub shr 5] := '.';
    NewMonster(1);
  End;

  For Y := 1 to 8 Do
    For X := 1 to 10 Do
    Begin
      mX := X;
      mY := Y+YSub Shr 5;

      If (mY > 0) And (mY <= MapLeng) Then
      Begin
        If (Map[mX, mY] = '>') And (Clk mod (16*4) = 48) Then
        Begin
          NewFire(X*32-16+15, YSub-16+Y*32 - YSub And 31,
                  {PI/2} Angle(-(YSub-16+Y*32-YSub And 31) + ShipY,
                               -(X*32-16+15) + ShipX), 1, 0);
          Sound(1000);
          NoSound;
        End;
      End;
    end;
End;

Begin
  LoadMap;
  InitScreen(MyScreen);
  GraphMode;
  DrawPCX(Screen, '0000009.PCX', 0, 0, Palette);
  For I := 0 to 255 do
    SetRGB256(I, Palette[I*3+0],
                 Palette[I*3+1],
                 Palette[I*3+2]);
  For I := 1 to MaxPicture do
  Begin
    InitPicture(Picture[I], 0, 0, 64, 64);
    GetImg(Screen, ((I-1) mod 10)*32, ((I-1) div 10)*32,
                   ((I-1) mod 10)*32+32, ((I-1) div 10)*32+32, Picture[I]);
  End;

  InitStars;
  Speed := 0;
  MainPos := StartY*32-128;
  ShipY := MainPos+128;

  ShipDir := 0;
  ShipX := StartX*32-16;
  Charge := 0;

  InitKey;
  Shield := 255;
  ShieldRel := 0;
  InitFirePixels;
  While not Kb^[1] do
  Begin
    Inc(Clk);
    If Keypressed Then ReadKey;
    ShipDir := 0;
    If Charge > 0 Then Dec(Charge);
    If (Kb^[57]) And (Charge = 0) Then
    Begin
      NewFire(_ShipX, _ShipY+MapPos-10, PI, 3, 1);
      Inc(Charge, 16);
    End;
    If Kb^[75] Then ShipDir := -1;
    If Kb^[77] Then ShipDir := +1;
    If Kb^[72] Then
    Begin
      Speed := Speed - 0.08;
      If Speed < 0 Then Speed := Speed - 0.04;
    End else
    If Kb^[80] Then
    Begin
      Speed := Speed + 0.08;
      If Speed > 0 Then Speed := Speed + 0.04;
    End else
    Begin
      If Speed > +0.06 Then Speed := Speed - 0.06 else
      If Speed < -0.06 Then Speed := Speed + 0.06 else
        Speed := 0;
    End;
    If ShipDir <> 0 Then
    Begin
      If Abs(ShipDX) < 2 Then ShipDX := ShipDX + ShipDir*0.1;
    End Else
    Begin
      If ShipDX > +0.2 Then ShipDX := ShipDX - 0.2 else
      If ShipDX < -0.2 Then ShipDX := ShipDX + 0.2 else
        ShipDX := 0;
    End;

    If Speed > 1 Then Speed := 1;
    If Speed < -1 Then Speed := -1;

    {pokus o pohyb}
    If Test Then
    Begin
      ShipX := ShipX + ShipDX*4;
      ShipY := ShipY + Speed*4;
      MainPos := MainPos + Speed*4;
      If MainPos > 0 Then
        MoveStars(-Speed);
    End Else
    Begin
      If Abs(ShipDX) > Abs(Speed) Then
        ShipDX := -ShipDX /4
      Else
        Speed := -Speed /2;
      Dec(ShieldRel, 8);
      Explosion(_ShipX, _ShipY, 8);
    End;

    If (ShipX < 0) Or (ShipX > 320) Then ShipDX := -ShipDX / 2;
    If ShipX < 0 Then ShipX := 0;
    If ShipX > 320 Then ShipX := 320;

    If MainPos < 0 Then
    Begin
      MapPos := 0;
    End Else
      MapPos := Trunc(MainPos);

    _ShipX := Trunc(ShipX);
    _ShipY := Trunc(ShipY-MapPos);


    Clear(MyScreen);

    ShowStars;
    ShowMap(MapPos);
    ProcMap(MapPos);


    MoveFires(MapPos);

    If Speed < 0 Then
      PutImgNull32(MyScreen, _ShipX-16, _ShipY-7, Picture[27+Clk shr 2 mod 3]);
    If (Speed > 0) And ((Clk div 5) mod 3 = 0) Then
      PutImgNull32(MyScreen, _ShipX-16, _ShipY-16, Picture[30]);

    If abs(ShipDX) < 0.5 Then
      PutImgNull32(MyScreen, _ShipX-16, _ShipY-16, Picture[24]) Else
    If ShipDX < 0 Then
      PutImgNull32(MyScreen, _ShipX-16, _ShipY-16, Picture[26]) Else
    If ShipDX > 0 Then
      PutImgNull32(MyScreen, _ShipX-16, _ShipY-16, Picture[25]);
    ShowFires(MapPos);

    If ShieldRel <> 0 Then
    Begin
      Inc(Shield, Sgn(ShieldRel));
      Dec(ShieldRel, Sgn(ShieldRel));
      If Shield < 1 Then Shield := 1;
    End;
    Line(MyScreen, 0, 198, Shield, 198, 14);
    Line(MyScreen, 0, 199, Shield, 199, 14);
    Line(MyScreen, Shield+1, 198, 319, 198, 1);
    Line(MyScreen, Shield+1, 199, 319, 199, 1);

    Exploding;
    DrawExplosion;
    MoveMonster;
    DrawMonster;
    Blit(Screen, MyScreen);
  End;
  DoneKey;
  UniGr.TextMode;
End.